﻿namespace Phoenix.Model.Core.Management
{
    using Phoenix.Model.Bll.Domain;
    using Phoenix.Model.Bll.Interface;
    using Phoenix.Model.Dal;
    using Phoenix.Presenter.Interfaces;

    /// <summary>
    /// Provides tools to check login
    /// </summary>
    public class LoginModel
    {
        #region Fields

        private ILoginPresenter presenter;
        private IUserRepository repository = RepositoryFactory.Get<IUserRepository>();

        #endregion Fields

        #region Constructors

        /// <summary>
        /// Initializes a new instance of the <see cref="LoginModel"/> class.
        /// </summary>
        /// <param name="presenter">The presenter.</param>
        public LoginModel(ILoginPresenter presenter)
        {
            this.presenter = presenter;
            this.presenter.UsersLoading += (sender, e) => this.LoadUsers();
            this.presenter.UserConnecting += (sendern, e) => this.Connect(e.Data);
        }

        #endregion Constructors

        #region Methods

        private void Connect(User user)
        {
            this.presenter.Succeeded = (this.presenter.Password == user.DecryptPassword());
        }

        private void LoadUsers()
        {
            this.presenter.Users = repository.GetAllRows();
        }

        #endregion Methods
    }
}