﻿namespace Phoenix.View.Frame
{
    using System;
    using System.Diagnostics;
    using System.Windows.Forms;

    using log4net;

    using Phoenix.Helpers.Winforms.Logging;

    /// <summary>
    /// Contains the logs.
    /// </summary>
    public partial class LogFrame : TranslateableForm
    {
        #region Fields

        private TextBoxTraceListener listener;
        private ILog logger;

        #endregion Fields

        #region Constructors

        /// <summary>
        /// Initializes a new instance of the <see cref="LogFrame"/> class.
        /// </summary>
        public LogFrame()
        {
            InitializeComponent();
            this.TranslateForm();

            this.listener = new TextBoxTraceListener(this.tb_Log);
            Trace.Listeners.Add(this.listener);

            //Console.SetOut(new TextBoxConsoleRedirection(this.tb_Log));

            this.logger = LogManager.GetLogger(typeof(LogFrame));
            this.logger.Debug("Log frame is ready to listen!");
        }

        #endregion Constructors

        #region Methods

        private void btn_Clear_Click(object sender, EventArgs e)
        {
            this.tb_Log.Text = string.Empty;
        }

        private void btn_Copy_Click(object sender, EventArgs e)
        {
            Clipboard.SetText(this.tb_Log.Text);
        }

        private void btn_OpenDir_Click(object sender, EventArgs e)
        {
            GuiManager.OpenLogDirectory();
        }

        private void LogFrame_Load(object sender, EventArgs e)
        {
        }

        #endregion Methods
    }
}