﻿namespace Phoenix.Plugin.Test
{
    using System;
    using System.Windows.Forms;

    using Phoenix.Plugins.Host;
    using Phoenix.Plugins.Host.Interfaces;

    public partial class Main : Form, IHost
    {
        #region Constructors

        public Main()
        {
            InitializeComponent();
        }

        #endregion Constructors

        #region Properties

        public new ContainerControl Container
        {
            get { return this; }
        }

        #endregion Properties

        #region Methods

        private void Configure(IPlugable plugin)
        {
            ToolStripItem menu = new ToolStripMenuItem(plugin.MenuName);
            menu.Click += (sender, e) => plugin.Execute();

            this.tsmi_Plugins.DropDownItems.Add(menu);
        }

        private void ConfigurePlugins(string assemblyName)
        {
            PluginRepository.Load(this, assemblyName);
            PluginRepository.Instance.Configure(x => this.Configure(x));
        }

        private void tsmi_LoadPlugin_Click(object sender, EventArgs e)
        {
            try
            {
                DialogResult dr = this.ofd_Plugins.ShowDialog();
                if (dr != DialogResult.OK) return;

                string assemblyName = this.ofd_Plugins.FileName;
                ConfigurePlugins(assemblyName);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, ex.GetType().Name, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        #endregion Methods
    }
}